# Civilization 4 (c) 2005 Firaxis Games
#
# Move plot highlighting mod component
# by TGA (adapted by 12monkeys)
#
# Email: The_great_Apple@hotmail.com

from CvPythonExtensions import *
import sys

#import CvEventManager
from CvScreenEnums import *
from PyHelpers import *
import CvUtil
from AStarTools import *

class MoveHighlighter:	

	def __init__(self, eventManager):
	
		self.HighlightActive = 0

		eventManager.addEventHandler("Update", self.onUpdate)
		eventManager.addEventHandler("mouseEvent", self.onMouseEvent)
		eventManager.addEventHandler("unitSelected", self.onUnitSelected)
		eventManager.addEventHandler("unitMove", self.onUnitMove)

	def onUpdate(self, argsList):
		if(self.HighlightActive == 1):
			pUnit = CyInterface().getHeadSelectedUnit()
			if not (pUnit):
				AStarMoveArea().dehighlightMoveArea()
			else:
				AStarMoveArea().highlightMoveArea(pUnit)
			HighlightActive = 0
				
	def onMouseEvent(self, argsList):
		self.HighlightActive = 1

	def onUnitSelected(self, argsList):
		self.HighlightActive = 1

	def onUnitMove(self, argsList):
		self.HighlightActive = 1

